/*
	============================================================================
	Name        : offsetGen.h
	Author      : kdesnos
	Version     : 1.0
	Copyright   : CeCILL-C, IETR, INSA Rennes
	Description : Generation of an array of the offsets used in the 
	              computation of the depth map.
	============================================================================
*/

#ifndef OFFSET_GEN_H
#define OFFSET_GEN_H
#include "preesm.h"

/**
* Generation of an array of the offsets used in the computation 
* of the depth map.
*
* @param nbIterations
*        The number of offset to generate.
* @param disparities
*        Output array for the generated offsets.
*/
void deltasGen (int nbIterations, OUT unsigned char *deltas);

#endif
