/*
	============================================================================
	Name        : scale.c
	Author      : ggautier
	Version     : 1.0
	Copyright   : CECILL-C, IETR, INSA Rennes
	Description : Apply scale factor on output image.
	============================================================================
*/
#include "scale.h"

void applyScale(int size, int scale, int nbSlice, IN unsigned char *in, OUT uint8_t *out) {
	int maxIdx = size/nbSlice;
	if (out != NULL) {
		int i;
		for (i=0; i < maxIdx; i++) {
			out[i] = in[i]*scale;
		}
	} else {
		int i;
		for (i=0; i < maxIdx; i++) {
			in[i] *= scale;
		}
	}
}
