# What is in this folder?

The Preesm project containing all tests applications, as well
as data generated by Preesm:
flat PiMM graphs, srdag of this graphs, Gantts of a few scenarios.

## Prerequisite

- Preesm 3.18 or later
- bash version 4 or later
- Python3, with modules lxml, networkx and sortedcontainers

Additionnaly, to execute the application code you will need:
- gcc or clang
- cmake (compilation tool)
- SDL2 (GUI library)


## How to generate what has to be generated?

0. configure the right path to your Preesm install (variable ```preesmDir```), in all "generate....sh" scripts
1. run generateAllFlatPis.sh
2. run generateInstrumented.sh
3. copy yourself the timings from the folder generatedData/timings in generatedData/timings_import
   (with numeric values instead of forumlae)
3. (bis) in the generatedData/timings_import folder, use the script
   x86toOdroidXU3.sh to convert timings for Odroid
4. run generateAllGantt.sh
5. go to the preesm_to_ibm_scripts folder to generate problem data

## Additional scripts

./generatedData/timings_import/X86toOdroidXU3.py:

	Converts x86 timings to OdroidXU3.


./generatedData/flatpis/addDelays.py:

	Adds delays to a graph given IBM json schedule file.


./generatedData/json/runIBMjsonPreesm.bash:

	Runs the IBM json schedule on Preesm. Path to preesm must be modified.

./commandLinePreesm.sh:

	Generic script to launch Preesm (copied from Preesm CLI).


## Remarks

- what is the meaning of the value 'span' in _stats_pgantt.xml ? It is always 0.
