#!/bin/bash

scenarios='stereoGG/stereoGG_1CoreX86_flattened.scenario reinforcement/1coreTraining_flattened.scenario SIFT/extractSIFT_1Corex86_flattened.scenario'

preesmDir="/home/ahonorat/Documents/logiciels/sources/preesm_3.18.0"

preesmProjectDir="/home/ahonorat/Documents/dev/2019_dac/data_preesm"

## +  reinforcement/1corePrediction_flattened.scenario
## is in the same directory of Training ...

## +  SIFT/extractSIFT_1Corex86_pmedium_flattened.scenario
## is in the same directory of normal SIFT ...


## +  stereoGG/stereoGG_1CoreX86_plarge_flattened.scenario
## but around 1400 firings to schedule, seems to be too much
## done by hand

DIR=$(cd $(dirname $0) && pwd)
for scenario in ${scenarios}
do
    ${DIR}/commandLinePreesm.sh "${preesmDir}" "${preesmProjectDir}" "CodegenInstrumented.workflow" "${scenario}"
done


folder_root='/home/ahonorat/Documents/dev/2019_dac/data_preesm/Code'
folders='SIFT reinforcement stereoGG'
exeNames=(extract cacla stereo)
arrayIndex=0

function generateTiming() {
    cd "${folder_root}/$1"
    mkdir -p "build/"
    cd "build/"
    cmake ..
    make clean
    make -j 2
    cd "Release"
    cp ../../generated/analysis.csv .
    ./${exeNames[$2]}
    cp analysis.csv "${folder_root}/../generatedData/timings/./${exeNames[$2]}_$3_analysis.csv"
}


mkdir -p "${folder_root}/../generatedData/timings"
for folder in ${folders}
do
    generateTiming "${folder}" ${arrayIndex} "normal"
    ((arrayIndex++))    
done


${DIR}/commandLinePreesm.sh "${preesmDir}" "${preesmProjectDir}" "CodegenInstrumented.workflow" "SIFT/extractSIFT_1Corex86_pmedium_flattened.scenario"
generateTiming "SIFT" "0" "medium"

${DIR}/commandLinePreesm.sh "${preesmDir}" "${preesmProjectDir}" "CodegenInstrumented.workflow" "reinforcement/1corePrediction_flattened.scenario"
generateTiming "reinforcement" "1" "prediction"


