class Props:
    def __init__(self, clusterProc, scenarTimeFloatConverter, appSizeIntConverter, archiSizeStrConverter, archiSpeedStrConverter, globalTimingFactor, actorTimingFactors, weightedCoreNumber):
        self.clusterProc = clusterProc
        self.scenarTimeFloatConverter = scenarTimeFloatConverter
        self.appSizeIntConverter = appSizeIntConverter
        self.archiSizeStrConverter = archiSizeStrConverter
        self.archiSpeedStrConverter = archiSpeedStrConverter
        self.globalTimingFactor = globalTimingFactor
        self.actorTimingFactors = actorTimingFactors
        self.weightedCoreNumber = weightedCoreNumber

class Archi:
    def __init__(self, dicoArchiId, dicoMem, dicoProc, links, archiName, slamVersion):
        self.dicoArchiId = dicoArchiId
        self.dicoMem = dicoMem
        self.dicoProc = dicoProc
        self.links = links
        self.archiName = archiName
        self.slamVersion = slamVersion

class App:
    def __init__(self, dicoActorId, dicoPortsNm, dicoPortsId, appName, appKind, counterActors, counterEdges, counterPorts, srdagGraph, mapActorShortNameId, minII):
        self.dicoActorId = dicoActorId
        self.dicoPortsNm = dicoPortsNm
        self.dicoPortsId = dicoPortsId
        self.appKind = appKind
        self.appName = appName
        self.counterActors = counterActors
        self.counterEdges = counterEdges
        self.counterPorts = counterPorts
        self.srdagGraph = srdagGraph
        self.mapActorShortNameId = mapActorShortNameId
        self.minII = minII
        
class Scenar:
    def __init__(self, dicoTimings, dicoTimingsMax, dicoSizes, sortedListPrefix):
        self.dicoTimings = dicoTimings
        self.dicoTimingsMax = dicoTimingsMax
        self.dicoSizes = dicoSizes
        self.sortedListPrefix = sortedListPrefix

    def getShortName(self, actorLongName):
        for l,prefix in self.sortedListPrefix:
            if actorLongName.find(prefix, 0) == 0:
                return actorLongName.replace(prefix, "")
        return actorLongName


def simpleXPathWithName(path, prefix):
    subparts = path.split("/")
    auxPrefix = "/"+prefix
    return auxPrefix.join(subparts)
